#version 120

#if defined(OPENGL_ES) || defined(GL_ES)
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif

///////////////////////////////////////////////////////////
// Uniforms
uniform float u_time;
///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;

const float width=0.02;
const float band=192.0;
const float speed=1.0;
const float sharp=10.0;

const float PI = 3.14159;

//Cӂ̃xNgxƂȂp𐳋KĕԂ
float ExAng(vec2 uv){
    float as = asin(uv.y/length(uv))*2.0/PI;
    float ang=  as * step(1.0, sign(uv.x)) 
          +(2.0-as)* (1.0-step(1.0,sign(uv.x)));
    return fract(ang*0.25);
}
//𐶐
float rnd(float p){
    return fract(sin(dot(vec2(p,floor(u_time*speed)),vec2(12.9898,78.233))) * 43758.5453);
}
//Ԃ𐶐(̓[v\Ƃ邽߂ɍőlo^)
float irnd(float p,float M){
    float ri = rnd(mod(ceil(p),M));
    float rf = rnd(mod(floor(p),M));
    return mix(rf,ri,fract(p)); //mix(x,y,a) <=`
}
//]si2DB׼ޱ݁j
mat2 rot(float r){ 
    return mat2(cos(r),sin(r),sin(r),cos(r));
}

void main()
{
    float time=u_time*0.02; //vt[K
    vec2 uv = vec2( abs(2.0 - v_texCoord.x * 4.0) -1.0,
                              v_texCoord.y * 2.0 - 1.0);//WK

    //Ring
    float d= clamp(1.0-abs((1.0-time*2.3) - length(uv)),0.0,1.0);
    vec4 col_Ring = step(v_texCoord.x,0.5)*(vec4(0.3,0.3,1.0,1.0) * d*d*d*d*d*d*d*d*d*d)+
                    step(0.5,v_texCoord.x)*(vec4(1.0,0.3,0.3,1.0) * d*d*d*d*d*d*d*d*d*d);
    col_Ring.a=max(0.0,col_Ring.a*min(1.0-time,3.0*time));
    
    //Wave
    float EA = ExAng(uv);

    float wave=(0.8+width*irnd(EA*band,band))*pow(time,0.3);
    d = 1.0-abs(wave-length(uv));
    vec4 col_Wave = vec4(0.4,1.0,0.9,1.0) * d*d*d*d*d*d*d*d*d*d;
    wave=(0.8+width*irnd(EA*band,band))*time*time;
    d = 1.0-abs(wave-length(uv));
    col_Wave = col_Wave+vec4(0.4,1.0,0.9,1.0) * d*d*d*d*d*d*d*d*d*d;
    col_Wave.a = max(0.0,col_Wave.a *(1.0-time*1.05));

    //ball
    vec2 ballpos = rot(PI*2.0*time)*vec2(1.0,0.0)*min(1.0,time*1.3);
    d=min(length(ballpos-uv),
      min(length(rot(PI*2.0/3.0)*ballpos-uv),
          length(rot(PI*4.0/3.0)*ballpos-uv)));
    d=pow(1.0-d,3);
    vec4 col_Ball = step(v_texCoord.x,0.5)*vec4(1.0,0.3,0.3,1.0)*d*d +
                    step(0.5,v_texCoord.x)*vec4(0.3,0.3,1.0,1.0)*d*d;
    col_Ball=col_Ball * (1.0-time);
    float t=1.0-time*1.5;
    col_Ball.a=max(0.0,col_Ball.a*t*t);
    vec4 col=col_Ring+col_Wave+col_Ball;
    col.a=min(col.a,1.0-length(uv));
    gl_FragColor = vec4(col);
    
}