#version 120

#if defined(OPENGL_ES) || defined(GL_ES)
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif

///////////////////////////////////////////////////////////
// Uniforms
uniform sampler2D u_diffuseTexture;
uniform float u_Alpha;
uniform float u_Rev;
uniform float u_time;
uniform float u_EyeU;
uniform float u_xTime;  //]^Ci1.00.0j
///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;

void main(){
    vec2 tx = vec2(v_texCoord.x * 2.0 - 1.0 , v_texCoord.y);
    float d = distance(vec2(abs(tx.x),tx.y),vec2(0.5,0.5));

    float colEx;
    float stp;
     colEx=1.0;
     stp=step(distance(abs(tx),vec2(0.60,0.59)),0.53);
     colEx=stp*0.0+(1.0-stp)*colEx;
     stp=step(distance(abs(tx),vec2(0.75,0.50)),0.54);
     colEx=stp*1.0+(1.0-stp)*colEx;
     stp=step(distance(abs(tx),vec2(0.67,0.60)),0.48);
     colEx=stp*0.0+(1.0-stp)*colEx;

    colEx=1.0-colEx*0.2;
    float cu = 0.9*colEx;
    float cd = (0.3+0.5*tx.y)*colEx;
    float ce = cd+0.1*sin(u_time*0.09);
    vec3 c1 = vec3(cu,ce,cd);
    vec3 c2 = vec3(cd,ce,cu);
    vec3 col = (c1-c2)*step(0.0,sign(tx.x)*(-u_Rev*2.0+1.0))+c2;  
    
    float a=clamp((0.49-d)*30.0,0.0,1.0)*u_Alpha;

    //]pFϓ
    d=distance(abs(tx),vec2(0.5,0.5))*2.0;
    

    c1=vec3( 1.0,0.5,0.5);
    c2=vec3(0.5,0.5, 1.0);
    col =col*(1.0-u_xTime) + (col+(c1-c2)*step(0.0,sign(tx.x)*(-u_Rev*2.0+1.0))+c2)*u_xTime; 
    //Eye
    vec2 uvE=(vec2(mod(v_texCoord.x,0.5)*2.0,v_texCoord.y)+vec2(u_EyeU,0.0))*vec2(1.0/3.0,1.0);
    vec4 ECol = texture2D(u_diffuseTexture, uvE);
    col=col * (1.0-ECol.a*0.8) + ECol.rgb *ECol.a;
    gl_FragColor = vec4(col,a);
}