#version 120

#if defined(OPENGL_ES) || defined(GL_ES)
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif

uniform float u_time;
varying vec2 v_texCoord;

float getD(float t,float d1,float d2){
    float y=mod(u_time*t+1.0,3.0);
    return clamp(min(d1*(y-v_texCoord.y),d2*(v_texCoord.y-y))+1.0,0.0,1.0);
}
void main(void) {
    vec3 col=vec3(0.05,0.06,0.1);
    //Up
    col+=vec3( 0.05, 0.05, 0.05)*getD( 0.011,100.0,5.0);
    col+=vec3( 0.02, 0.02, 0.02)*getD( 0.005,100.0,3.0);
    col+=vec3( 0.02, 0.02, 0.03)*getD( 0.007,100.0,5.0);
    col+=vec3(-0.02,-0.02,-0.03)*getD( 0.008,100.0,6.0);
    col+=vec3( 0.03, 0.03, 0.03)*getD(-0.007,5.0,100);
    col+=vec3( 0.02, 0.02, 0.03)*getD(-0.008,3.0,100);
    col+=vec3( 0.03, 0.03, 0.03)*getD(-0.003,9.0,100);
    col+=vec3(-0.03,-0.03,-0.03)*getD(-0.004,9.0,100);
    //Frame
    float d=0.5*clamp(max(abs(0.5-v_texCoord.x),abs(0.5-v_texCoord.y))*2.0*10.0-9.0,0.0,1.0);
    col+=vec3(1.0,1.0,1.0)*d*(1.0+0.2*sin(u_time*0.1));
    gl_FragColor = vec4(col,1.0);
}