#version 120

#if defined(OPENGL_ES) || defined(GL_ES)
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif

varying vec2 v_texCoord;
const float PI  = 3.141592653589793;
uniform float u_time;

uniform sampler2D TX1;
uniform sampler2D TX2;


//Cӂ̃xNgxƂȂp𐳋KĕԂ
float ExAng(vec2 uv){
    float as = asin(uv.y/length(uv))*2.0/PI;
    float ang=  as * step(1.0, sign(uv.x)) 
          +(2.0-as)* (1.0-step(1.0,sign(uv.x)));
    return fract(ang*0.25);
}
void main(void) {
  vec4 baseCol = texture2D(TX1, v_texCoord);
  vec2 LPos = vec2(sin(u_time*0.05)*0.5+0.5,cos(u_time*0.05)*0.5+0.5);

  vec2 uv=mod(v_texCoord*10.0,1.0)-vec2(0.5,0.5);
  float ofsCol=abs(0.5-abs(0.5-ExAng(uv))*2.0)*2.0;

  float addCol = 1.0-clamp(distance(LPos + vec2(ofsCol*1.5,ofsCol*1.2),v_texCoord),0.0,1.0);

  gl_FragColor.rgb=baseCol.rgb*(1.0+addCol*0.5);
  gl_FragColor.a=ceil(baseCol.r+baseCol.g+baseCol.b);
}

