#version 120

#if defined(OPENGL_ES) || defined(GL_ES)
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif

///////////////////////////////////////////////////////////
// Uniforms
uniform float u_time;
///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;

void main(){
    vec3 color[5];
    color[0]=vec3(1.0,0.3,0.3);
    color[1]=vec3(1.0,0.5,0.3);
    color[2]=vec3(1.0,1.0,0.3);
    color[3]=vec3(0.5,1.0,0.3);
    color[4]=color[3];

    float t = u_time/60.0;
    t=1.0-t+0.1,3.0;
    vec3 col = clamp(color[int(v_texCoord.x*4.0)]*t*t*t,0.0,1.0);
    gl_FragColor.rgb = col;

    float d=distance(vec2(mod(v_texCoord.x,0.25)*4.0,v_texCoord.y),vec2(0.5,0.5));
    gl_FragColor.a = clamp(pow(1.0-d,5.0),0.0,1.0);
}
